<?php
/*==================================================================================================
Clase para trabajar con mens contextuales.

	Especificaciones de las etiquetas XML:
		- MENUCONTEXTUAL: Elemento raiz en el se especifican los atributos del <DIV>
		- ITEM: Especificaciones de cada item.
		- SEPARADOR: Indica una linea divisoria entre items

	Especificaciones de atributos:
		- idctx: Identificador del menu contextual (DIV)
		- imgitem: La url de la imagen que acompaar al literal 
		- alignitem: La alineacin del texto del item (por defecto left)
		- textoitem: El literal del item
		- subflotante: Si el item despliega otro menu contextual. El valor es el id de se
		- maxanchu: Mxima anchura del menu contextual
		- swimg: Vale 1 si el menu tiene algn item con imagen y 0 en caso contrario
		- alpulsar: Nombre de la funcin javascript que se ejecutar en respuesta al evento onclick
		- clase: Estilo CSS que tendrn los item  menu contextual
		- origen_x: Posicin de origen, coordenada x
		- origen_y: Posicin de origen, coordenada y


	Especificaciones de eventos:
		 - Los eventos onmouseover y onmouseout estn implicitos en la clase por defecto
	Especificaciones de submenus:
		- Si una opcin lleva un submenu asociado el id de ste va en el atributo name del <TR>


==================================================================================================*/
class MenuContextual{

	/*---------------------------------------------------------------------------------------------
		Devuelve una cadena en formato HTML de un layer para usarlo como menu contextual
		Parametros: 
			- cadenaXML: Una cadena en formato XML con los atributos de cada item
	---------------------------------------------------------------------------------------------*/
	function CreaMenuContextual($cadenaXML){
		$idx=0;
		$layer="";
		$idctx="";
		$maxanchu=100;
		$swimg=0;
		$imgitem="";
		$alignitem="";
		$textoitem="";
		$clase="";
		$subflotante="";
		$origen_x="0";
		$origen_y="0";

		$gXML=new XmlPhp($cadenaXML,0); 
		$gXML->NodoRaiz();
		$atributosHTML=$gXML->Atributos();
		$atributosHTML=$gXML->TomaAtributoEspecial("maxanchu",$maxanchu,$atributosHTML);
		$atributosHTML=$gXML->TomaAtributoEspecial("swimg",$swimg,$atributosHTML);
		$atributosHTML=$gXML->TomaAtributoEspecial("clase",$clase,$atributosHTML);
		$atributosHTML=$gXML->TomaAtributoEspecial("idctx",$idctx,$atributosHTML);
		$atributosHTML=$gXML->TomaAtributoEspecial("origen_x",$origen_x,$atributosHTML);
		$atributosHTML=$gXML->TomaAtributoEspecial("origen_y",$origen_y,$atributosHTML);
		if (!$clase) $clase="menu_contextual";
		$layer.='<DIV class="'.$clase.'" id="'.$idctx.'" width='.$maxanchu.' style="visibility:hidden;position:absolute;top:'.$origen_y.';left:'.$origen_x.'" onmouseout="fuera_contextual(this)">';
		$nuitems=2;
		if ($gXML->PrimerNodoHijo()){
			$layer.=chr(13).'<TABLE  width='.$maxanchu.' border=0 cellspacing=0 cellpadding=0>';
			$layer.=chr(13).'<TR width='.$maxanchu.' height=3>'; // Primera linea
			$layer.='<TD width=3  background="../images/flotantes/esi.gif"></TD>'; 
			$layer.='<TD colspan=6 background="../images/flotantes/lsu.gif"></TD>'; 
			$layer.='<TD width=3  background="../images/flotantes/esd.gif"></TD>';
			$layer.='</TR>';
			$layer.=chr(13).'<TR  width='.$maxanchu.' height=3>'; // Linea de relleno
			$layer.='<TD rowspan=&& width=3 background="../images/flotantes/liz.gif"></TD>'; 
			$layer.='<TD rowspan=&& width=3></TD>'; 
			$layer.='<TD colspan=4></TD>'; 
			$layer.='<TD rowspan=&& width=3></TD>'; 
			$layer.='<TD rowspan=&& width=3 background="../images/flotantes/ldr.gif"></TD>';
			$layer.='</TR>';

			do{
				$nuitems++;
				$atributosHTML=$gXML->Atributos();
				$tiponodo=$gXML->NombreNodo();
				if ($tiponodo=="ITEM"){
					$atributosHTML=$gXML->TomaAtributoEspecial("imgitem",$imgitem,$atributosHTML);
					$atributosHTML=$gXML->TomaAtributoEspecial("textoitem",$textoitem,$atributosHTML);
					$atributosHTML=$gXML->TomaAtributoEspecial("subflotante",$subflotante,$atributosHTML);
					$atributosHTML=$gXML->TomaAtributoEspecial("alpulsar",$alpulsar,$atributosHTML);
					$atributosHTML=$gXML->TomaAtributoEspecial("alignitem",$alignitem,$atributosHTML);

					if ($alignitem==null) $alignitem="left";

					$clickcontextual=' onclick="'.$alpulsar.'" ';
					$oncontextual=' onmouseover="sobre_contextual(this)" ';
					//$offcontextual=' onmouseout="fuera_contextual(this)" ';
					$offcontextual="";

					$idx++;
					$layer.=chr(13).'<TR id='.$idx.' name="'.$subflotante.'" style="cursor:hand" width='.$maxanchu.' '.$clickcontextual.' '.$oncontextual.' '.$offcontextual.' height=20>'; // Linea de item
					if ($imgitem!=null){
						$imgonclick="";
						$layer.='<TD width=20 align=center id="TDimg-'.$idx .'"><IMG  width=16 style="cursor:hand" src="'.$imgitem.'"></TD>';
						$layer.='<TD width=3></TD>'; 
						$layer.='<TD align='.$alignitem.'  id="TDLit-'.$idx .'" width='.($maxanchu-38).' '.$atributosHTML.'>'.$textoitem.'</TD>';
					}
					else{
						if ($swimg==1){ // Hay algn item con imagen
							$layer.='<TD width=20></TD>'; 
							$layer.='<TD width=3></TD>'; 
							$layer.='<TD align='.$alignitem.' width='.($maxanchu-38).' '.$atributosHTML.'>'.$textoitem.'</TD>';
						}
						else{
							$layer.='<TD width=10></TD>'; 
							$layer.='<TD colspan=2 align='.$alignitem.' width='.($maxanchu-25).' ' .$atributosHTML.' >'.$textoitem.'</TD>';
						}
					}
					$layer.='<TD width=3 ';
					if ($subflotante!=null)
						$layer.=' valign=middle><IMG width=3 name="swsbfn" align=left src="../images/flotantes/swsbfn.gif"';
					$layer.='></TD>'; 
					$layer.='</TR>';
				}
				if ($tiponodo=="SEPARADOR"){ // Separadores
					$layer.=chr(13).'<TR  width='.$maxanchu.' height=16>'; // Linea de separacin
					$layer.='<TD colspan=4 background="../images/flotantes/sep.gif"></TD>';
					$layer.='</TR>';
				}
			}while($gXML->SiguienteNodoHermano());

			$layer.=chr(13).'<TR  width='.$maxanchu.' height=3>'; // Linea de relleno
			$layer.='<TD colspan=4></TD>'; 
			$layer.='</TR>';

			$layer.=chr(13).'<TR width='.$maxanchu.' height=3>'; // ltima linea
			$layer.='<TD width=3 background="../images/flotantes/eii.gif"></TD>'; 
			$layer.='<TD colspan=6 background="../images/flotantes/lin.gif"></TD>'; 
			$layer.='<TD width=3 background="../images/flotantes/eid.gif"></TD>';
			$layer.='</TR>';
			$layer.='</TABLE>'; 
			$layer.='<INPUT type=hidden value="-1">'; // Representar el ndice seleccionado
			$layer.='</DIV>'; 
		}
		$pnuitems="rowspan=".$nuitems;
		$layer=ereg_replace( "rowspan=&&",$pnuitems, $layer );
		return($layer);
	}
}	
?>