// ************************************************************************************************
//  Libreria de scripts de Javascript
// Copyright 2003-2005 Jos Manuel Alonso. Todos los derechos reservados.
// Fichero: ArbolVistaXML.js
// Este fichero implementa las funciones javascript de la clase ArbolVistaXML.php
// *************************************************************************************************
var currentNodo=null;      // Guarda el ltimo nodo resaltado
var oldNodo=null;      // Guarda el penltimo nodo resaltado
var currentINPUT=null;  // Es el objeto INPUT usado en la edicin del nodo
var currentLiteral=null;  // Guarda el literal del nodo
var currentRama=""; // Guarda estado actual de la rama
var currentTDRama=null // Guarda objeto TD, punto de pivote (edicin)
var currentbackground=null // Guarda el bckground del nodo 
var currentnodocolor=null // Guarda el color del nodo 
var currentnodobackground=null // Guarda el background del nodo 

var botonraton=null;

//-----------------------------------------------------------------------------------------------------------------------
//	 Gestiona el despliegue y contraccin de nodos
//	 Parmetro:
//		- ttab: Tipo de tabla
//		- o: Elemento IMG de signo del nodo
//		- n: Nivel del elemento en el arbol
//-----------------------------------------------------------------------------------------------------------------------
function clickImagenSigno(o,pathimg,n){
		var displai
		nivel=parseInt(n)
		switch(o.value){
			case "menos_t" :
				o.value="mas_t"
				o.src=pathimg+"/mas_t.gif"
				displai="none"
				break;
			case "menos_c" :
				o.value="mas_c"
				o.src=pathimg+"/mas_c.gif"
				if (nivel==0)
				    o.src=pathimg+"/mas_root.gif"
				displai="none"
				break;
			case "mas_t" :
				o.value="menos_t"
				o.src=pathimg+"/menos_t.gif"
				displai="block"
				break;
			case "mas_c" :
				o.value="menos_c"
				o.src=pathimg+"/menos_c.gif"
				if (nivel==0)
				    o.src=pathimg+"/menos_root.gif"
				displai="block"
				break;
		}
		while(o.tagName!="TR" )
			o=document.all[o.sourceIndex+1]
		o.style.display=displai
		otd=document.all[o.sourceIndex-1]
		if (EsAncestro(otd,currentNodo)) resalta(otd)
}
//-----------------------------------------------------------------------------------------------------------------------
//	 Resalta el nodo seleccionado
//	 Parmetro:
//		- o: Elemento TD del arbol que tiene el literal del nodo o el TD de la imagen
//-----------------------------------------------------------------------------------------------------------------------
function resalta(o){
	if (currentNodo){
		currentNodo.style.backgroundColor=currentnodobackground
		currentNodo.style.color=currentnodocolor
	}
	currentnodocolor=o.style.color // Guarda el color del nodo 
	currentnodobackground=o.style.backgroundColor // Guarda el background del nodo 
	o.style.backgroundColor="#0a266a"; // Azul marino
	o.style.color="#ffffff"; // Blanco
	oldNodo=currentNodo
	currentNodo=o;
}
//-----------------------------------------------------------------------------------------------------------------------
//	 Deja de resaltar el nodo seleccionado
//	 Parmetro:
//____________________________________________________________________________
function desresalta(o){
	o.style.backgroundColor=currentnodobackground
	o.style.color=currentnodocolor
}
//-----------------------------------------------------------------------------------------------------------------------
// Devuelve el estado del nodo: si esta contraido o replegado
// Parmetro:
//	- o: Elemento TD del arbol que tiene el literal del nodo o el TD de la imagen de signo
// Devuelve: 
//		- true: Si el nodo est desplegado 
//		- false: Si el nodo est replegado 
//-----------------------------------------------------------------------------------------------------------------------
function NodoDesplegado(o){
	var resta=0
	if (o.tagName!="IMG") resta=4
	o=document.all[o.sourceIndex-resta]
	signo=o.value.split("_")
	if (signo[0]=="menos" ) return(true)
	return(false)
}
//-----------------------------------------------------------------------------------------------------------------------
// Devuelve el nivel del nodo
// Parmetro:
//	- o: Cualquier elemento TD de la tabla nodo
//-----------------------------------------------------------------------------------------------------------------------
function toma_nivel(obj){
	var o=obj
	while (o.tagName!="TABLE"){
		o=o.parentElement
	}
	o=o.parentElement
	while (o.tagName!="TABLE"){
		o=o.parentElement
	}
	var Mnivel=o.id.split("-") // Toma el nivel donde est 
	var nivel=Mnivel[1]
	return(nivel)
}
//-----------------------------------------------------------------------------------------------------------------------
// Despliega un nivel el nodo indicado
// Parmetro:
//	- o: Elemento TD que tiene el literal del nodo o el TD de la imganen de signo
//-----------------------------------------------------------------------------------------------------------------------
function despliega(o,pathimg){
	var resta=0
	if (o.tagName!="IMG") resta=4
	nivel=toma_nivel(o)
	o=document.all[o.sourceIndex-resta]
	signo=o.value.split("_")
	if (signo[0]=="mas" ) clickImagenSigno(o,pathimg,nivel)
}
//-----------------------------------------------------------------------------------------------------------------------
// Simula un click sobre la imagen de signo del nodo
// Parmetro:
//	- o: Elemento TD del arbol que tiene el literal del nodo o el TD de la imagen
//-----------------------------------------------------------------------------------------------------------------------
function clicknodo(o,pathimg,btn){
	var resta=0
	if (o.tagName!="IMG") resta=4
	nivel=toma_nivel(o)
	o=document.all[o.sourceIndex-resta]
	var	signo=o.value.split("_")
	if(btn==1){
			if (signo[0]=="mas"  || 	signo[0]=="menos" ) clickImagenSigno(o,pathimg,nivel)
	}
	else{
			if (signo[0]=="mas" ) clickImagenSigno(o,pathimg,nivel)
	}
}
//-----------------------------------------------------------------------------------------------------------------------
// Repliega el nodo indicado
// Parmetro:
//	- o: Elemento TD del arbol que tiene el literal del nodo o el TD de la imagen
//-----------------------------------------------------------------------------------------------------------------------
function repliega(o){
	var resta=0
	if (o.tagName!="IMG") resta=4
	nivel=toma_nivel(o)
	o=document.all[o.sourceIndex-resta]
	signo=o.value.split("_")
	if (signo[0]=="menos" ) clickImagenSigno(o,nivel)
}
//-----------------------------------------------------------------------------------------------------------------------
// Hace visible un nodo desplegando la rama en la que est 
// Parmetro:
//	- o: Elemento TD del arbol que tiene el literal del nodo
//-----------------------------------------------------------------------------------------------------------------------
function asomar(o){
	o=asomando(o)
	while (o!=null){
		o=asomando(o);
	}
}
//-----------------------------------------------------------------------------------------------------------------------
function asomando(o){
	while (o.tagName!="TABLE"){
		o=o.parentElement
	}
	o=o.parentElement
	while (o.tagName!="TABLE"){
		o=o.parentElement
	}
	var Mnivel=o.id.split("-") // Toma el nivel donde est 
	var nivel=parseInt(Mnivel[1])
	if (nivel==0) return(null) // Ha llegado al primer nivel
	o=o.parentElement
	while (o.tagName!="TR"){
		o=o.parentElement
	}
	o=document.all[o.sourceIndex-1]
	var oimg=document.all[o.sourceIndex-4]
	signo=oimg.value.split("_")
	if (signo[0]=="mas" ) clickImagenSigno(oimg,nivel)
	return(o)
}
//-----------------------------------------------------------------------------------------------------------------------
// Recupera el nodo padre del nodo enviado como parmetro 
// Parmetro:
//	- o: Elemento TD de un nodo
//-----------------------------------------------------------------------------------------------------------------------
function NodoPadre(o){
	while (o.tagName!="TABLE"){
		o=o.parentElement
	}
	o=o.parentElement
	while (o.tagName!="TABLE"){
		o=o.parentElement
	}
	var Mnivel=o.id.split("-") // Toma el nivel donde est 
	var nivel=parseInt(Mnivel[1])
	if (nivel==0) return(null) // Ha llegado al primer nivel no tiene padre
	o=o.parentElement
	while (o.tagName!="TR"){
		o=o.parentElement
	}
	o=document.all[o.sourceIndex-1] 
	return(o)
}
//-----------------------------------------------------------------------------------------------------------------------
// Recupera el nmero de hermanos de un nodo 
// Parmetro:
//	- o: Elemento TD de un nodo
//-----------------------------------------------------------------------------------------------------------------------
function NumHermanos(o){
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	o=o.parentElement // Padre TABLE (tabla nodo)
	o=o.parentElement // Padre TD
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	var nh=0;
	var attrId;
	for (i=0;i<o.children.length;i++){
		attrId=o.children(i).getAttribute("id")
		if (attrId) nh++ // Si tiene atributo id es que es un TR de nodo sino es una tabla con hijos
	}
	return(nh)
}
//-----------------------------------------------------------------------------------------------------------------------
// Recupera el hermano anterior de un nodo 
// Parmetro:
//	- o: Elemento TD de un nodo
//-----------------------------------------------------------------------------------------------------------------------
function HermanoAnterior(o){
	var gnodo=null
	var idTRNodo=GetIdTRNodo(o) // Toma identificador del TR del Nodo
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	o=o.parentElement // Padre TABLE (tabla nodo)
	o=o.parentElement // Padre TD
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	var nh=0;
	var attrId;
	for (i=0;i<o.children.length;i++){
		attrId=o.children(i).getAttribute("id")
		if (attrId) {
			if (attrId==idTRNodo) break;
			gnodo=o.children(i)
		}
	}
	if (!gnodo) return(null) // No hay hermano anterior
	var oTD=gnodo.all.tags("TD")
	for (i=0;i<oTD.length;i++){
		attrId=oTD.item(i).getAttribute("id")
		if (attrId) { // El nico TD con atributo id es el TD del literal del nodo
			return(oTD.item(i))
		}
	}
}
//-----------------------------------------------------------------------------------------------------------------------
// Informa si el nodo es el ltimo de los hermanos 
// Parmetro:
//	- o: Elemento TD literal de un nodo
//-----------------------------------------------------------------------------------------------------------------------
function EsUltimoHermano(o){
	var o=document.all[o.sourceIndex-4] // Toma objeto de la imagen de signo 
	var attrvalue=o.getAttribute("value")
	patron=/_c/i // Busca valor de imagen con codo, que indicara que es ltimo nodo de la rama
	var pos=attrvalue.search(patron)
	if (pos<0)return false
	return(true)
}
//-----------------------------------------------------------------------------------------------------------------------
// Recupera el nmero de hijos de un nodo 
// Parmetro:
//	- o: Elemento TD literal de un nodo
//-----------------------------------------------------------------------------------------------------------------------
function NumHijos(o){
	while (o.tagName!="TBODY"){
		if (o.tagName=="INPUT"){
			return(0) // fin del arbol 
		}
		o=document.all[o.sourceIndex+1]
	}
	var nh=0;
	var attrId;
	for (i=0;i<o.children.length;i++){
		attrId=o.children(i).getAttribute("id")
		if (attrId) nh++
	}
	return(nh)
}
//-----------------------------------------------------------------------------------------------------------------------
// Comprueba parentezco entre dos nodos
// Parmetros:
//		- nodopadre: Elemento TD de un nodo
//		- nodohijo: Elemento TD de un nodo
// Devuelve:
//		- true si el nodopadre es un ancestro del nodo hijo
//		- false en caso contrario
//-----------------------------------------------------------------------------------------------------------------------
function EsAncestro(nodopadre,nodohijo){
	o=nodohijo
	while (o!=null){
		while (o.tagName!="TABLE"){
			o=o.parentElement
		}
		o=o.parentElement
		while (o.tagName!="TABLE"){
			o=o.parentElement
		}
		var Mnivel=o.id.split("-") // Toma el nivel  
		var nivel=parseInt(Mnivel[1])
		if (nivel==0) return(false) // Ha llegado al primer nivel
		o=o.parentElement
		while (o.tagName!="TR"){
			o=o.parentElement
		}
		nwo=document.all[o.sourceIndex-1] // es el literal
		nwi=document.all[o.sourceIndex-5] // es la imagen 
		if (nwo==nodopadre) return true
		if (nwi==nodopadre) return true
		o=nwo
	}
	return(false)
}
//-----------------------------------------------------------------------------------------------------------------------
//	 Gestiona el despliegue y contraccin de nodos a travs del literal del nodo
//	 Parmetro:
//		- o: Elemento TD del nodo que contiene el literal
//-----------------------------------------------------------------------------------------------------------------------
function clickLiteralNodo(o,pathimg){
		resalta(o);
		clicknodo(o,pathimg,botonraton);
}
//____________________________________________________________________________
//	
//	Inserta un nodo en el rbol
// Especificaciones:
//		Los parmetros recibidos son:
//			- sufijonodo: Sufijo del identificador de nodo ( gruposaulas,gruposordenadores,etc)
//			- nwid: Identificador asignado al nuevo registro
//			- tablanodo: Tabla nodo generada para el nuevo registro (rbol de un slo un elemento)
//____________________________________________________________________________
function insertando_nodo(tablanodo){
	var patron = new RegExp("<IMG ")  // Toma semitabla para insertar nodo en rbol
	var posa=tablanodo.search(patron); 
	patron = new RegExp("</TR>") 
	var posb=tablanodo.search(patron); 
	semitablanodo="<TD>"+tablanodo.substr(posa,posb-posa);
	var swhijos=TieneHijos(currentNodo); // Comprueba si el nodo actual tiene hijos
	if (swhijos){ // Si los tiene modifica la imagen de signo del nodo hijo
			 patron = new RegExp("nada_c","gi") 
			semitablanodo=semitablanodo.replace(patron,"nada_t"); 
	}
	insertar_nodo(currentNodo,semitablanodo) // Inserta el nuevo nodo
}
//____________________________________________________________________________
//	
//	Inserta un nodo nevo
//	 Parmetro:
//			- o: El objeto TD  que contiene el literal del nodo que va a ser padre 
//			- tbinfo: Cadena con los TD's de la segunda parte de la tabla nodo
//							(de la imagen de signo en adelante, sta inclusive)
//____________________________________________________________________________
function insertar_nodo(o,tbinfo){
	var oid=o.id // Guarda el identificador del currentNodo para no peder su referencia
	contador_nodo=document.all["nodo_count"].value // Toma siguiente identificador de nodo
	var swhijos=TieneHijos(o) 
	var TDRama=OrigenRama(o,swhijos);
	currentRama=TDRama.innerHTML // Guarda Informacin de la rama completa
	if (swhijos)
		gPuntoDePivote=PuntoDePivote(currentRama,true); // Guarda punto de pivote (tiene ms hijos)
	else
		gPuntoDePivote=PuntoDePivote(currentRama,false,GetIdTRNodo(o)); // Guarda punto de pivote
	var nwtablanodo=""
	if (!swhijos){	
		nwtablanodo+='<TR style="display:block">'
		nwtablanodo+='<TD>'
		var nivel=parseInt(toma_nivel(o))+1
		nwtablanodo+='<TABLE id="tablanivel-'+nivel+'" border=0 cellspacing=0 cellpadding=0>'
	}
	nwtablanodo+='<TR id=TRNodo-'+contador_nodo+'>';
	nwtablanodo+='<TD>';
	nwtablanodo+='<TABLE border=0 cellspacing=0 cellpadding=0>'
	nwtablanodo+='<TR height="16px">'
	nwtablanodo+=camino_nodo(o)
	var oimg=document.all[o.sourceIndex-4] // El objeto imagen de signo del nodo
	var idsigno=oimg.getAttribute("value");
	var cuessig=idsigno.split("_")
	var srcIMG=oimg.getAttribute("src");
	var tbsIMG=srcIMG.split("/");
	var urlIMG=""
	for (i=0;i<tbsIMG.length-1;i++)
		urlIMG=urlIMG+tbsIMG[i]+"/" // Toma la url base de la imagen de signo
	if (cuessig[1]=="c" || cuessig[1]=="root") // El nodo es el ltimo hermano
		nwtablanodo+='<TD width="16px"><IMG src="'+urlIMG+'nada.gif" width="16px" height="16px"></TD>';
	else  // El nodo NO es el ltimo hermano
		nwtablanodo+='<TD width="16px"><IMG src="'+urlIMG+'nada_l.gif" width="16px" height="16px"></TD>';
	nwtablanodo+='<TD width="3px"></TD>'
	nwtablanodo+=tbinfo // El trozo de tabla final ( es la aportada a la funcin) 
	nwtablanodo+='</TR>' 
	nwtablanodo+='</TABLE>'
	nwtablanodo+='</TD>';
	nwtablanodo+='</TR>';
	if (!swhijos){ 
		nwtablanodo+="</TABLE>";
		nwtablanodo+='</TD>'
		nwtablanodo+='</TR>'
	}
	nwrama=currentRama.substr(0,gPuntoDePivote) // Primer trozo
	nwrama+=nwtablanodo // Nueva tabla nodo
	nwrama+=currentRama.substr(gPuntoDePivote,currentRama.length-gPuntoDePivote) // Segundo trozo
	TDRama.innerHTML=nwrama
	o=document.getElementById(oid); // Vuelve a recuperar el nodo actual 
	currentNodo=o;
	if (!swhijos) 
		cambia_signo(o,1); // Coloca el signo "menos" para el nuevo nodo padre
	document.all["nodo_count"].value=parseInt(contador_nodo)+1 // Incrementa el contador de nodos
}
//____________________________________________________________________________
//	
//	 Devuelve la primera parte de la tabla del nodo (hasta la imagen del signo exclusive)
//	 Parmetro:
//			- o: Cualquier objeto TD del nodo
//____________________________________________________________________________
function camino_nodo(o){
	var trozosTD=GetTablaNodo(o); // Recupera tabla nodo
	var numTD=trozosTD.length;
	var camino="";
	for (i=0;i<numTD-4;i++) 
		camino+=trozosTD[i];
	return(camino);
}
//____________________________________________________________________________
//	
//	 Devuelve la segunda parte de la tabla del nodo (desde la imagen del signo hasta el literal)
//	 Parmetro:
//			- o: Cualquier objeto TD del nodo
//____________________________________________________________________________
function info_nodo(o){
	var trozosTD=GetTablaNodo(o); // Recupera tabla nodo
	var numTD=trozosTD.length;
	var camino="";
	for (i=numTD-4;i<numTD;i++) 
		camino+=trozosTD[i];
	return(camino);
}
//____________________________________________________________________________
//	
//	 Devuelve el objeto desde el cual se puede variar el "innerHTML" (siempre es TD)
//	 Parmetro:
//			- o: Cualquier objeto TD del nodo que va a ser padre
//			- swh:  Indica si el nodo tiene hijos (true) o no (false)
//____________________________________________________________________________
function OrigenRama(o,swh){
	if (swh){ // Tiene ms hijos
		o=document.all[o.sourceIndex+1]
		while (o.tagName!="TD"){
			o=document.all[o.sourceIndex+1]
		}
		return(o) // Encuentra objeto
	}
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	o=o.parentElement // Padre TABLE
	o=o.parentElement // Padre TD
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	o=o.parentElement // Padre TABLE De donde se coje el nivel
	o=document.all[o.sourceIndex-1] // El objeto TD que contiene la rama entera
	return(o) // Encuentra punto de insercin
}
//____________________________________________________________________________
//	
//	Busca la posicin donde se deber dividir la cadena de texto HTML para incluir o
//	eliminar un nodo.
//		 Parametros:
//			- rama: El contenido HTML del objeto que contiene el HTML a variar (siempre TD) 
//			- swh: Es true si el nodo tiene ms hijos y false en caso contrario
//			- idTRnodo: Identificador del objeto TR que contiene la tabla nodo
//____________________________________________________________________________
function PuntoDePivote(rama,swh,idTRnodo){
	var pos=0;
	if (swh){ // Tiene ms hijos
		patron="<TR "
		pos=rama.search(patron); 
		return(pos)
	}
	var o=document.getElementById(idTRnodo); // Recupera el TR del nodo
	trHTML=o.outerHTML
	var patron = new RegExp("<TR id="+idTRnodo+">")
	pos=rama.search(patron); 
	pos+=trHTML.length
	return(pos)
}
//____________________________________________________________________________
//	
//	 Recupera la tabla que representa el nodo
//	 Parmetro:
//			- o: Cualquier objeto TD del nodo
//	 Devuelve:
//			- Una matriz con un elemento por objeto TD de la tabla
//____________________________________________________________________________
function GetTablaNodo(o){
	var i=0;
	var trozos=new Array();
	if (o.tagName=="IMG")
		o=o.parentElement
	o=o.parentElement
	var oTD=o.all.tags("TD")
	for (i=0;i<oTD.length;i++){
		trozos[i]=oTD.item(i).outerHTML
	}
	return(trozos);
}
//____________________________________________________________________________
//	
//	 Recupera el identificador del nodo (id del objeto TR)
//	 Parmetro:
//			- o: Cualquier objeto TD del nodo
//	 Devuelve:
//			- El identificador del TR que contiene la tabla nodo 
//____________________________________________________________________________
function GetIdTRNodo(o){
	o=o.parentElement //  TR
	o=o.parentElement //  TBODY
	o=o.parentElement //  TABLE (tabla nodo)
	o=o.parentElement //  TD
	o=o.parentElement //  TR
	var attrid=o.getAttribute("id");
	return(attrid);
}
//____________________________________________________________________________
//	
//	 Devuelve true si el nodo tiene hijos
//	 Parmetros:
//			- o: El elemento TD de un nodo que tiene contiene el literal 
//____________________________________________________________________________
function TieneHijos(o){
	o=document.all[o.sourceIndex+1]
	while (o.tagName!="TD"){
		if (o.tagName=="INPUT"){
			return(false) // fin del arbol, encuentra el input del contador de nodos
		}
		o=document.all[o.sourceIndex+1]
	}
	o=document.all[o.sourceIndex+1]
	while (o.tagName!="TD"){
		if (o.tagName=="INPUT"){
			return(false) // fin del arbol, encuentra el input del contador de nodos
		}
		o=document.all[o.sourceIndex+1]
	}
	o=document.all[o.sourceIndex+1]
	if (o.tagName=="TABLE")	return(true)
	return(false)
}
//____________________________________________________________________________
//	
//	Cambia la imagen de signo de un nodo al intentar insertarle un hijo o eliminarle un hijo
// Parametros:
//	- o: El objeto TD del nodo que va a ser padre 
//	- sw: Indica si se le ha aadido un hijo o eliminado el nico hijo
//				1: Insercin
//				2: Eliminacin
//____________________________________________________________________________
function cambia_signo(o,sw){
	var nivel=toma_nivel(o)
	var otd=document.all[o.sourceIndex-5] // Recupera el TD que contiene la imagen de signo del nodo
	imgHTML=otd.innerHTML
	if (sw==1)	{ // Se ha aadido un nodo, se pone como imagen de signo: menos_X
		if (nivel>0){
			patron=/nada_/gi
			imgHTML=imgHTML.replace(patron,"menos_")
		}
		else{
			patron=/nada_c/gi
			imgHTML=imgHTML.replace(patron,"menos_root")
		}
		var stronclick="clickImagenSigno(this,"+nivel+")";
		patron=/>/gi
		imgHTML=imgHTML.replace(patron,' style="cursor:hand" onclick="'+stronclick+'">')
		otd.innerHTML=imgHTML
	}
	else{ // Se ha eliminado un nodo, se pone como imagen de signo: nada_X
		if (nivel>0){
			patron=/menos_/gi
			imgHTML=imgHTML.replace(patron,"nada_")
		}
		else{
			patron=/menos_root/gi
			imgHTML=imgHTML.replace(patron,"nada_c")
		}
		patron=/ onclick=/i // Va a eliminar atributo onclick
		var pos=imgHTML.search(patron)
		pos++; // Adelanta el blanco de comienzo
		var posa=pos
		var swcomillas=false
		for (var i=pos;i<imgHTML.length;i++){
				if (imgHTML.charAt(i)=='"') swcomillas=!swcomillas;
				if (imgHTML.charAt(i)==">" || imgHTML.charAt(i)==" ") 
					if (!swcomillas) break;
				pos++;
		}
		var posb=pos
		nwimgHTML=imgHTML.substr(0,posa)
		nwimgHTML+=imgHTML.substr(posb,imgHTML.length-posb)
		imgHTML=nwimgHTML  // Elimina atributo onclick

		patron=/ style=/i // Va a eliminar atributo style
		pos=imgHTML.search(patron)
		pos++
		posa=pos
		swcomillas=false
		for (var i=pos;i<imgHTML.length;i++){
				if (imgHTML.charAt(i)=='"') swcomillas=!swcomillas;
				if (!swcomillas)
					if (imgHTML.charAt(i)==">" || imgHTML.charAt(i)==" ") break;
				pos++;
		}
		posb=pos
		nwimgHTML=imgHTML.substr(0,posa)
		nwimgHTML+=imgHTML.substr(posb,imgHTML.length-posb)
		imgHTML=nwimgHTML // Elimina atributo style

		otd.innerHTML=imgHTML // Vuele a reescribir el contenido HTML
	}
}
//____________________________________________________________________________
//	
//	 Toma atributos de un texto HTML
//____________________________________________________________________________
function toma_atributo(txtHTML,atrib){
	var i=0,posa,posb,longi;
	var swcomillas=false;
	posa=txtHTML.search(" "+atrib+"=");
	if (posa<0) retun(null) // No existe atributo
	posb=posa+atrib.length+2  // Pasa al signo "=" del atributo
	for (i=posb;i<txtHTML.length;i++){
		if (txtHTML.charAt(i)=='"') swcomillas=!swcomillas // Tiene en cuenta si va entre comillas
		if (txtHTML.charAt(i)==">" || txtHTML.charAt(i)==" "){
			if(!swcomillas){
				var atributoHTML=txtHTML.substr(posb,i-posb)
				if (atributoHTML.charAt(0)=='"') // Tiene comillas
					atributoHTML=atributoHTML.substr(1,atributoHTML.length-2)
				return(atributoHTML)
			}
		}
	}
	return(null)
}
//____________________________________________________________________________
//
//	Edita un nodo para poder cambiar su literal
//	 Parametros:
//			- o: El objeto TD que contiene el literal del nodo
//____________________________________________________________________________
function editar_nodo(o){
	desresalta(o)
	var literalnodo=o.innerText
	currentLiteral=literalnodo  // Guarda literal del nodo
	var wsize=literalnodo.length
	var trozosTD=GetTablaNodo(o); // Recupera tabla del nodo
	var numTD=trozosTD.length;
	var tablaedicion="";
	tablaedicion+='<TABLE border="0" cellspacing="0" cellpadding="0">'
	tablaedicion+='<TR height="16px">'
	for (i=0;i<numTD-4;i++) 
		tablaedicion+=trozosTD[i]; // Camino del nodo
	var TDimg=trozosTD[numTD-4]	// Imagen del signo
	var srcimg=toma_atributo(TDimg,"src"); // Toma source de la imagen
	tablaedicion+='<TD width="16px"><IMG src="'+srcimg+'" width="16px" height="16px"></TD>';
	TDimg=trozosTD[numTD-3]	// Imagen del nodo
	srcimg=toma_atributo(TDimg,"src"); // Toma source de la imagen
	tablaedicion+='<TD width="16px"><IMG src="'+srcimg+'" width="16px" height="16px"></TD>';
	tablaedicion+='<TD width="4px"></TD>';
	tablaedicion+='<TD ><INPUT onblur="fin_editar_nodo(this)" size='+wsize+' class=input_nodo id="input-xxx" type=text value="'+literalnodo+'">'
	tablaedicion+='</TR>' 
	tablaedicion+='</TABLE>'
	while (o.tagName!="TABLE"){
		o=document.all[o.sourceIndex-1]
	}
	currentTDRama=document.all[o.sourceIndex-1] // Guarda objeto TD donde insertar la tabla nodo modificada
	currentRama=currentTDRama.innerHTML // Guarda el contenido para restablecer en su caso
	currentTDRama.innerHTML=tablaedicion
	currentINPUT=document.getElementById("input-xxx");
	currentINPUT.focus();
}
//____________________________________________________________________________
//	
//	Controla la salida del input de la edicion del nodo y modifica el nodo en su caso
//	Especificaciones:
//		Esta funcin llama a una funcin llamada "evento_modificacion" pasando como parmetros
//		un objeto de argumentos de evento: e cuya funcin constructora se
//		describe en este fichero: objArgsEvento()
//			
//____________________________________________________________________________
function fin_editar_nodo(){
	var oid=currentNodo.id
	var nwliteralnodo=currentINPUT.value
	if (nwliteralnodo==""){
		nwliteralnodo="Nuevo nombre";
		currentINPUT.value="Nuevo nombre"
	}
	var patron=new RegExp(">"+currentLiteral+"<") 
	var nwrama=currentRama.replace(patron,">"+nwliteralnodo+"<")
	currentTDRama.innerHTML=nwrama
	currentNodo=document.getElementById(oid); // Vuelve a recuperar el nodo actual 
	resalta(currentNodo)
	var e=new objArgsEvento();
	e.literalnodo=nwliteralnodo // Envia como argumentos el literal y el identificador del literal
	e.idnodo=currentNodo.getAttribute("id");
	evento_modificacion(e) // Llama a la funcin 
}
//____________________________________________________________________________
//	
//	Modifica el literal de un nodo
//	 Parametros:
//			- o: El objeto TD que contiene el literal del nodo
//			- nwliteral: El nuevo literal del nodo
//  Especificaciones:
//			Si el parametro objeto "o" es nulo, se considera el nodo actual 
//____________________________________________________________________________
function modifica_literal_nodo(o,nwliteral){
	if (o!=null && o.tagName=="TD"){
		o.innerText=nwliteral
	}
}
//____________________________________________________________________________
//	
//	Modifica el literal de un nodo por su iD
//	 Parametros:
//			- idNodo: El literal del nodo
//			- nwliteral: El nuevo literal del nodo
//____________________________________________________________________________
function modifica_literal_nodoPorId(idNodo,nwliteral){
	var o=document.getElementById(idNodo); // Toma objeto 
	if (o!=null)
		o.innerText=nwliteral
}
//____________________________________________________________________________
//	
//	Modifica la imagen de un nodo
//	 Parametros:
//			- o: El objeto TD que contiene el literal del nodo
//			- nwurlimg: La nueva url de la imagen
//____________________________________________________________________________
function modifica_imagen_nodo(o,nwurlimg){
	if (o!=null){
		var o=document.all[o.sourceIndex-2] // El objeto anterior
		o.src=nwurlimg
	}
}
//____________________________________________________________________________
//	
//	Elimina el literal de un nodo por su iD
//	 Parametros:
//			- idNodo: El identificador del nodo
//____________________________________________________________________________
function elimina_nodoPorId(idNodo){
	var o=document.getElementById(idNodo); // Toma objeto 
	if (o!=null){
		resalta(o);
		eliminar_nodo(o)
	}
}
//____________________________________________________________________________
//	
//	 Elimina el contenido de un nodo del arbol
//	 Parmetro:
//			- oTD: Cualquier objeto TD del nodo al que se quiere eliminar su contenido
//____________________________________________________________________________
function eliminar_contenidonodo(oTD){
	var coid=currentNodo.id // Guarda el identificador del currentNodo para no perder su referencia
	var oid=oTD.id // Guarda el identificador del nodo  para no perder su referencia
	idTRNodo=GetIdTRNodo(oTD) // Toma identificador del TR del Nodo
	var o=oTD.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	o=o.parentElement // Padre TABLE
	o=o.parentElement // Padre TD
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	o=o.parentElement // Padre TABLE De donde se coje el nivel
	var TDRama=document.all[o.sourceIndex-1] // El objeto TD que contiene la rama entera
	var rama=TDRama.innerHTML // El cdigo HTML de la rama
	var oTR=document.getElementById(idTRNodo); // Recupera el TR del nodo
	var trHTML=oTR.outerHTML 
	var patron=new RegExp("<TR id="+idTRNodo+">")
	pos=rama.search(patron); 
	var posa=pos
	var posb=posa+trHTML.length
	pos=posb
	for (var i=pos;i<rama.length;i++){ // Busca siguiente etiqueta
		if (rama.charAt(i)=="<" )  break;
		pos++;
	}
	posb=pos;
	if ("<TR style="==rama.substr(pos,10)) {// Si tiene hijos ...
		pos++;
		var contTR=1 // Control de etiquetas anidadas
		for (i=pos;i<rama.length;i++){ // Busca cierre </TR>
			if ("<TR"==rama.substr(i,3)) contTR++
			if ("</TR"==rama.substr(i,4)) contTR--
			if (contTR==0){
				posb=i+5
				break;
			}
		}
	}
	posa+=trHTML.length
	var nwrama=rama.substr(0,posa)
	nwrama+=rama.substr(posb,rama.length-posb)
	TDRama.innerHTML=nwrama
	oTD=document.getElementById(oid); // Vuelve a recuperar el objeto 
	currentNodo=document.getElementById(coid); // Vuelve a recuperar el objeto  
	cambia_signo(oTD,2)
}
//____________________________________________________________________________
//	
//	 Elimina un nodo del arbol
//	 Parmetro:
//			- oTD: Cualquier objeto TD del nodo a eliminar
//		Especificaciones:
//			Si el nodo tiene hijos tambin se eliminarn
//____________________________________________________________________________
function eliminar_nodo(oTD){
	var o=oTD
	var swuh=EsUltimoHermano(oTD) // Switch para saber si es el ltimo hermano
	currentNodo=NodoPadre(currentNodo) // Cambia el nodo actual al nodo Padre
	var nh=NumHijos(currentNodo) // Toma nmeros de hijos del nodo padre (o sea numero de hermanos)
	var swunicohijo=false // Switch para saber si es el nico hermano
	if (nh==1) { 
		swunicohijo=true
		o=currentNodo // Si es el ltimo hermano el proceso siguiente se traslada al nodo padre
	}
	var oid=currentNodo.id // Guarda el identificador del currentNodo para no perder su referencia
	if (!swunicohijo){ // Si no es hijo nico ...
		if (swuh){  // Si es el ltimo hermano
			var hermant=HermanoAnterior(oTD) // Toma nodo hermano anterior
			var hermantid=hermant.id // Guarda el identificador del nodo hermano
		}
	}
	idTRNodo=GetIdTRNodo(o) // Toma identificador del TR del Nodo ( en su caso es el del padre)
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	o=o.parentElement // Padre TABLE
	o=o.parentElement // Padre TD
	o=o.parentElement // Padre TR
	o=o.parentElement // Padre TBODY
	o=o.parentElement // Padre TABLE De donde se coje el nivel
	var TDRama=document.all[o.sourceIndex-1] // El objeto TD que contiene la rama entera
	var rama=TDRama.innerHTML // El cdigo HTML de la rama
	var oTR=document.getElementById(idTRNodo); // Recupera el TR del nodo
	var trHTML=oTR.outerHTML 
	var patron=new RegExp("<TR id="+idTRNodo+">")
	pos=rama.search(patron); 
	var posa=pos
	var posb=posa+trHTML.length
	pos=posb
	for (var i=pos;i<rama.length;i++){ // Busca siguiente etiqueta
		if (rama.charAt(i)=="<" )  break;
		pos++;
	}
	if ("<TR style="==rama.substr(pos,10)) {// Si tiene hijos ... (siempre se cumple)
		pos++;
		var contTR=1 // Control de etiquetas anidadas
		for (i=pos;i<rama.length;i++){ // Busca cierre </TR>
			if ("<TR"==rama.substr(i,3)) contTR++
			if ("</TR"==rama.substr(i,4)) contTR--
			if (contTR==0){
				posb=i+5
				break;
			}
		}
	}
	if (swunicohijo) posa+=trHTML.length
	var nwrama=rama.substr(0,posa)
	nwrama+=rama.substr(posb,rama.length-posb)
	TDRama.innerHTML=nwrama
	o=document.getElementById(oid); // Vuelve a recuperar el objeto 
	currentNodo=o; // Vuelve a tomar la referencia del nodo actual 
	if (swunicohijo) // El nodo era el nico hermano se debe cambiar la imagen de signo del padre
		cambia_signo(currentNodo,2)
	else{
		if (swuh){ // Si era el ltimo hermano ... y no era hijo nico
			hermant=document.getElementById(hermantid); // Vuelve a recuperar el hermano anterior 
			var otdimg=document.all[hermant.sourceIndex-5] // El objeto td contenedora de la imagen de signo del nodo hermano anterior
			var imgHTML=otdimg.innerHTML
			patron=/_t/gi // Cambio de imagen y value 
			imgHTML=imgHTML.replace(patron,"_c")
			otdimg.innerHTML=imgHTML
			if (TieneHijos(hermant)) // Si el hermano anterior tiene hijos debe cambiar imagen nada_l
				CambiaLosnada_l(hermant,0)
		}
	}
	resalta(currentNodo)
}
//-----------------------------------------------------------------------------------------------------------------------
// Cambia las imgenes nada_l cuando se elimina un nodo terminal 
// Parmetro:
//	- o: Elemento TD literal del nodo padre
//	- profun: profundidad relativa del nodo
//-----------------------------------------------------------------------------------------------------------------------
function CambiaLosnada_l(o,profun){
	var objTD,attrId;
	o=document.all[o.sourceIndex+1]
	while (o.tagName!="TBODY"){
		o=document.all[o.sourceIndex+1]
	}
	for (var i=0;i<o.children.length;i++){
		oTR=o.children(i)
		attrId=oTR.getAttribute("id") // Toma los TR's
		if (attrId){
			var tagTDs=oTR.all.tags("TD") // Toma los TD's
			for (var j=0;j<tagTDs.length;j++){
				objTD=tagTDs.item(j)
				attrId=objTD.getAttribute("id")
				if (attrId){
					cambiando_nada_l(objTD,profun)
					if (TieneHijos(objTD))
						CambiaLosnada_l(objTD,profun+1)
				}
			}
		}
	}
}	
//-----------------------------------------------------------------------------------------------------------------------
// Cambia las imgenes nada_l 
// Parmetro:
//	- o: Elemento TD literal del nodo padre
//	- profun: profundidad relativa del nodo
//-----------------------------------------------------------------------------------------------------------------------
function cambiando_nada_l(o,profun){
	var oTD=document.all[o.sourceIndex-8-(profun*3)] // El objeto imagen de signo del nodo
	var imgHTML=oTD.innerHTML
	var patron=/nada_l/gi
	imgHTML=imgHTML.replace(patron,"nada")
	oTD.innerHTML=imgHTML
}
//____________________________________________________________________________
//	
//		Constructor del objeto argumentos de evento
//____________________________________________________________________________
function objArgsEvento(){
	this.literalnodo
	this.idnodo
	this.resul
}
//____________________________________________________________________________
//	
//	Devuelve el segundo dato de una cadena con formato xxxxxx-xxx que es id de un 
//	objeto
//  Parametro:
//		o: Objeto con el id segn el formato especificado
//____________________________________________________________________________
function toma_identificador(o){
	var cadena=o.id;
	var	iditem=cadena.split("-") // Toma el identificador 
	return(iditem[1]);
}
//____________________________________________________________________________
//	
//	Devuelve el primer dato de una cadena con formato xxxxxx-xxx que es sufijo de un 
//	objeto
//  Parametro:
//		o: Objeto con el id segn el formato especificado
//____________________________________________________________________________
function toma_sufijo(o){
	var cadena=o.id;
	var	iditem=cadena.split("-") // Toma el identificador 
	return(iditem[0]);
}
//____________________________________________________________________________
//	
//	Devuelve el literal de un nodo 
//	objeto
//  Parametro:
//	- oTD: Elemento TD literal de un nodo 
//____________________________________________________________________________
function toma_infonodo(oTD){
	return(oTD.innerHTML);
}
//____________________________________________________________________________
//
//	Se ejecuta cada vez que se mueve el puntero del ratn. Se usa para desmarca
//	cualquier item de menu contextual que estuviese activo
//____________________________________________________________________________
function click_de_raton_prov(){
	botonraton=event.button
	event.returnValue=true;
}

//____________________________________________________________________________
//
//	Redirecciona el evento onmousedown a la funcin de usuario especificada. 
//____________________________________________________________________________
document.onmousedown = click_de_raton_prov; // Redefine el evento onmousedown
